// Fichero Circulo.java

public class Circulo extends Geometria {
	static int numCirculos= 0;				//vaiable de clase ("static") y con acceso "package" (modificador acceso por 
											//defecto)
	public static final double PI= 3.14159; //variable de clase ("static"), pblica y no modificable ("final")
											//a todos los efectos se comporta como una constante
	public double x, y, r;
	
	//Definicin de los constructores
	//ATENCIN con el mbito de los identificadores. Los argumentos del constructor tienen mbito local (slo existen
	//dentro del mtodo) mientras que las variables miembros tienen un mbito ms general, en funcin, de sus modificadores
	//de visibilidad (que determinan dnde puede referenciarse a dicha variable). En este caso, los identificadores
	//de los argumentos coinciden con las variables miembros, y se sigue un criterio de precedencia de nombre, por el 
	//que prevalece el identificador con mbito ms reducido
	public Circulo(double x, double y, double r) {
		this.x= x;		//La referencia "this" se utiliza para referirse al ARGUMENTO IMPLCITO, es decir,
		this.y= y;		//al bojeto sobre el que se est aplicando el mtodo
		this.r= r;
		numCirculos++;
	}
	
	
	public Circulo(double r) {this(0.0, 0.0, r);} //se inicializa slo con el radio, por defecto, centro en origen
	public Circulo(Circulo c) {this(c.x, c.y, c.r);} //se inicializa el crculo con la referencia a otro objeto de su clase
	public Circulo() {this(0.0, 0.0, 1.0);} // sin argumentos, se considera un circulo de radio 1 centrado en el origen
	
	//Defincin de los mtodos abstractos de la superclase "Geometria"
	public double perimetro () { return 2 * PI * r; }
	public double area() {return PI * Math.pow(r, 2.0); }
	
	//Definicion de metodos propios de la clase Circulo
	
	//Mtodo de objeto para comparar dos circulos (el propio objeto que lo invoca 
	//con otro del que se pasa una referencia como argumento)
	public Circulo elMayor(Circulo c) {
		if (this.r>=c.r) return this; else return c;
	}
	
	//Mtodo de clase (modificador "static") para comparar dos circulos (dos objetos Circulo cualesquiera,
	//de los que se pasan sendas referencias
	public static Circulo elMayor(Circulo c1, Circulo c2) {
		if (c1.r >= c2.r) return c1; else return c2;
	}
}