// Fichero Geometria.java

public abstract class Geometria {
	// clase abstracta que no puede tener objetos, realmente no tiene sentido que haya objetos de la clase
	// geometra y por eso es abstracta. La clase se declara como publica (puede ser utilizada por cualquier clase, 
	// aunque sea de otro paquete). Las clases slo pueden ser "public" o "package" (valor por defecto, y 
	// utilizable slo por las clases del paquete a que pertenece)
	
	/* La clase Geometria es la base (raiz) de la jerarqua que utiliza la aplicacin y el resto de clases se 
	 * derivan a partir de esta (en realidad no es la base, pues en Java, todas las clases se derivan de la
	 * clase "Object" definida en el paquete "java.lang")
	 * La clase Geometra:
	 *		- no define ninguna variable miembro
	 *		- pero s DECLARA dos mtodos: "perimetro()" y "area()". Se declaran como "public", por lo que 
	 *		pueden ser invocados por otras clases, y como "abstract", indicando que no se da ninguna DEFINICIN 
	 *		(el cdigo de estas funciones se deja a que lo definan las clases derivadas, pues cada una calcular 
	 *		el rea de una forma diferente), pero s que interface tienen tales funciones
	 */
	 public abstract double perimetro();
	 public abstract double area();
}