// Fichero Rectangulo.java

public class Rectangulo extends Geometria {
	/* La clase "Rectangulo" se deriva de la clase "Geometria" (clausula extends).
	 * La subclase "Rectangulo" hereda de "Geometria" todos los campos y mtodos 
	 * que tenga, en este caso, slo la definicin de los mtodos abstractos "perimetro()"
	 * y "area()"
	 */
	 
	 // definicin de variables miembros (campos) de la clase Rectangulo
	 private static int numRectangulos = 0; // variable miembro de la clase "static", propia de la clase 
	 										// y no de cada objeto (existe sin necesidad de existir objetos de la clase)
	 										// Adems es privada (slo accesible por los mtodos de la propia clase)
	 										// Otros modificadores de acceso aparte de "private": "public" (accesible
	 										// para cualquier clase), "protected" (accesible por cualquier mtodo de 
	 										// la clase, cualquiera de sus subclases estn en el paquete que estn, o 
	 										// las clases del propio paquete), y "package" (valor por defecto si no 
	 										// se incluye modificador de acceso)
	 protected double x1, y1, x2, y2;		// variables miembros propias de cada objeto y con acceso protegido
	 
	 // Definicion del constructor de la clase:
	 //		- Mtodos especiales que se invocan automaticamente cuando se crea un objeto de la clase 
	 //		- No tienen tipo de vuelta
	 //		- Su nombre coinciden con el nombre de la clase
	 //		- Habitualmente estn sobrecargados, tienen el mismo nombre, pero distinto nmero de parmetros
	 public Rectangulo(double p1x, double p1y, double p2x, double p2y) {
	 	x1= p1x;
	 	y1= p1y;
	 	x2= p2x;
	 	y2= p2y;
	 	numRectangulos++;
	 }
	 
	 // Constructor por defecto (sin argumentos)
	 public Rectangulo () {
	 	this(0.0, 0.0, 1.0, 1.0);	// se utiliza la referencia "this" para referirse al propio objeto, con lo que
	 								// se invoca al constructor general definido con anterioridad
	 }
	 
	 // Definicin de los mtodos abstractos de la clase "Geometria" para la clase "Rectangulo"
	 public double perimetro () {
	 	return 2.0 * (Math.abs(x1-x2) + Math.abs(y1-y2)); // Se hace uso de los mtodos estticos de la clase "Math"
	 }
	 
	 public double area() {
	 	return Math.abs(x1-x2)*Math.abs(y1-y2);
	 }
} // Fin de la clase "Rectangulo"

	 
	 										
	  