// Fichero RectanguloGrafico.java

import java.awt.Graphics;
import java.awt.Color;

/*
 * Definicin de la clase "RectanguloGrafico", derivada de la clase "Rectangulo" y que a su vez, implementa
 * la interfaz "Dibujable" (los mtodos que declara esta interfaz)
 * Si implementase varias interfaces, stas se separaran por comas
 */
class RectanguloGrafico extends Rectangulo implements Dibujable {
	// La subclase, adems de tener los atributos de la superclase, tiene un atributo adicional, relevante
	// a la hora de dibujar el objeto, su color
	Color color;
	
	// Definicin del constructor
	public RectanguloGrafico(double x1, double y1, double x2, double y2, Color col) {
		
		// llamada al constructor de la superclase "Rectangulo", utilizando la referencia "super"
		super(x1, y1, x2, y2);
		// inicializacin del campo color del objeto
		this.color= col;		// en este caso, el uso de "this" es opcional
	}
	
	// Implementacin de los mtodos de la interfaz "Dibujable", el resto de mtodos son heredados de la superclase
	/*
	 * El mtodo "dibujar()" recibe como argumento un objeto "dw" de la clase Graphics. Esta clase define un contexto
	 * para realizar operaciones grficas en un panel, tales como establecer el color de las lneas, de fondo, el tipo
	 * de letra, etc. 
	 */
	public void dibujar(Graphics dw) {
		dw.setColor(color);
		dw.drawRect((int)x1, (int)y1, (int)(x2-x1), (int)(y2-y1)); // vertice superior izquierdo, anchura y altura
	}
	
	public void setPosicion(double x, double y) {
		;	// mtodo vaco, no hace falta pero es necesario definir para cumplir con la interfaz
	}
}